(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    104919,       2302]
NotebookOptionsPosition[    103904,       2266]
NotebookOutlinePosition[    104244,       2281]
CellTagsIndexPosition[    104201,       2278]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"MAIN", " ", "PROCEDURE"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"main", "[", 
      RowBox[{
      "q0_", ",", "xlist_", ",", "rlist_", ",", "t_", ",", "boundinterval_", 
       ",", "factorQ_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "qlist", ",", "slist", ",", "llist", ",", "templlist", ",", "qn", ",",
          "i", ",", "j"}], "}"}], ",", "   ", 
       RowBox[{"(*", 
        RowBox[{"rlist", ":", " ", 
         RowBox[{"replace", " ", "rules"}]}], "*)"}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"qlist", "=", 
         RowBox[{"projection", "[", 
          RowBox[{"q0", ",", "xlist"}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"factorQ", "\[NotEqual]", "1"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"qlist", "=", 
            RowBox[{"qlist", "/.", "rlist"}]}], ";", "   ", 
           RowBox[{"(*", "replacing", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"slist", "=", 
            RowBox[{"dSequence", "[", 
             RowBox[{
              RowBox[{"qlist", "[", 
               RowBox[{"[", 
                RowBox[{"-", "1"}], "]"}], "]"}], ",", "t"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"llist", "=", 
            RowBox[{"peIsolate", "[", 
             RowBox[{"slist", ",", "1", ",", "t", ",", "boundinterval"}], 
             "]"}]}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"llist", "=", 
            RowBox[{"{", "}"}]}], ";", "   ", 
           RowBox[{"(*", 
            RowBox[{
            "factor", " ", "decomposation", " ", "for", " ", "complex", " ", 
             "situations"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"qn", "=", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"List", "@@@", 
               RowBox[{"{", 
                RowBox[{"Factor", "[", 
                 RowBox[{"qlist", "[", 
                  RowBox[{"[", 
                   RowBox[{"-", "1"}], "]"}], "]"}], "]"}], "}"}]}], ")"}], 
             "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{
             "eliminate", " ", "sum", " ", "of", " ", "squares", " ", "and", 
              " ", "signle", " ", "a", " ", "b"}], ",", " ", 
             RowBox[{
              RowBox[{"left", " ", "to", " ", "be", " ", "done"}], "..."}]}], 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{"qn", "=", 
            RowBox[{"qn", "/.", "rlist"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"i", "=", "1"}], ",", 
             RowBox[{"i", "\[LessEqual]", 
              RowBox[{"Length", "[", "qn", "]"}]}], ",", 
             RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"llist", ",", 
               RowBox[{"peIsolate", "[", 
                RowBox[{
                 RowBox[{"dSequence", "[", 
                  RowBox[{
                   RowBox[{"qn", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", "t"}], "]"}], ",", 
                 "1", ",", "t", ",", "boundinterval"}], "]"}]}], "]"}]}], 
            "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Print", "[", "llist", "]"}], ";"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"llist", "=", 
            RowBox[{"Select", "[", 
             RowBox[{"llist", ",", 
              RowBox[{
               RowBox[{"#", "\[NotEqual]", 
                RowBox[{"{", "}"}]}], "&"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"templlist", "=", 
            RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"i", "=", "1"}], ",", 
             RowBox[{"i", "\[LessEqual]", 
              RowBox[{"Length", "[", "llist", "]"}]}], ",", 
             RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
             RowBox[{"For", "[", 
              RowBox[{
               RowBox[{"j", "=", "1"}], ",", 
               RowBox[{"j", "\[LessEqual]", 
                RowBox[{"Length", "[", 
                 RowBox[{"llist", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ",", 
               RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"templlist", ",", 
                 RowBox[{
                  RowBox[{"llist", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "[", 
                  RowBox[{"[", "j", "]"}], "]"}]}], "]"}]}], 
              "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Do", "[", "   ", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{
                 RowBox[{"double", " ", "'"}], 
                 RowBox[{"Do", "'"}], " ", "is", " ", "more", " ", 
                 "efficient", " ", "than", " ", 
                 RowBox[{"double", " ", "'"}], 
                 RowBox[{"For", "'"}]}], ",", " ", 
                RowBox[{
                "but", " ", "does", " ", "not", " ", "work", " ", "here"}]}], 
               "*)"}], "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Do", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"templlist", ",", 
                   RowBox[{
                    RowBox[{"llist", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{"j", ",", "1", ",", 
                   RowBox[{"Length", "[", 
                    RowBox[{"llist", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"Length", "[", 
                  RowBox[{"[", "llist", "]"}], "]"}]}], "}"}]}], "]"}], ";"}],
             "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"llist", "=", "templlist"}], ";", "\[IndentingNewLine]", 
           RowBox[{"qlist", "=", 
            RowBox[{"qlist", "/.", "rlist"}]}]}]}], "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{"Print", "[", "llist", "]"}], "*)"}], "\[IndentingNewLine]",
          "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"llist", "\[Equal]", 
            RowBox[{"{", "}"}]}], ",", 
           RowBox[{
            RowBox[{"Print", "[", "\"\<No samples points found.\>\"", "]"}], 
            ";", 
            RowBox[{"Return", "[", 
             RowBox[{"{", "}"}], "]"}]}], ","}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"check", "[", 
          RowBox[{"q0", ",", 
           RowBox[{"Append", "[", 
            RowBox[{"xlist", ",", "t"}], "]"}], ",", "rlist", ",", 
           RowBox[{"lift", "[", 
            RowBox[{"qlist", ",", "llist", ",", 
             RowBox[{"Append", "[", 
              RowBox[{"xlist", ",", "t"}], "]"}]}], "]"}]}], "]"}], "]"}]}]}],
       "\[IndentingNewLine]", 
      RowBox[{"(*", "]", "*)"}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.629691666293857*^9, 3.629691953042138*^9}, {
   3.6296919961625757`*^9, 3.629692055515029*^9}, {3.6296924289558887`*^9, 
   3.629692447090728*^9}, {3.629692500669112*^9, 3.6296925017611303`*^9}, {
   3.629693049973399*^9, 3.629693180900634*^9}, {3.629693289740827*^9, 
   3.62969329525247*^9}, {3.6298698234721212`*^9, 3.629869823748411*^9}, {
   3.630366338916111*^9, 3.630366351924364*^9}, {3.6303664067351713`*^9, 
   3.630366456253834*^9}, {3.6303664864621353`*^9, 3.630366532511026*^9}, {
   3.630366633846942*^9, 3.630366660800211*^9}, {3.630366789671072*^9, 
   3.630366801375306*^9}, 3.6303669839441833`*^9, {3.6303670168075323`*^9, 
   3.630367053839184*^9}, {3.630367149368209*^9, 3.630367253152507*^9}, {
   3.630367321721513*^9, 3.630367362752928*^9}, {3.6303674084567757`*^9, 
   3.6303674314081697`*^9}, {3.630368376009678*^9, 3.630368378100267*^9}, {
   3.630368410440174*^9, 3.630368434190939*^9}, {3.6303684696576357`*^9, 
   3.630368492784503*^9}, {3.630368580875215*^9, 3.6303686136821747`*^9}, {
   3.630368646264976*^9, 3.630368649120022*^9}, {3.630385669636094*^9, 
   3.630385768288182*^9}, {3.630385925547552*^9, 3.630385930695497*^9}, {
   3.630386006205622*^9, 3.630386055438388*^9}, 3.630386093861007*^9, 
   3.630386207488677*^9, {3.630386289824241*^9, 3.630386301422411*^9}, {
   3.630386388829114*^9, 3.630386389301083*^9}, {3.630386534783534*^9, 
   3.630386691481661*^9}, {3.6303868249493*^9, 3.63038684693039*^9}, {
   3.630386980419841*^9, 3.630387006063697*^9}, 3.630387115794251*^9, {
   3.63038767702266*^9, 3.630387705482256*^9}, {3.630387756560111*^9, 
   3.630387834870691*^9}, {3.630387865025281*^9, 3.630387915169496*^9}, {
   3.630387986970712*^9, 3.630387995310901*^9}, {3.63038807109253*^9, 
   3.630388083098357*^9}, {3.630388222148276*^9, 3.630388226442873*^9}, 
   3.630388503967983*^9, {3.630388548524175*^9, 3.630388612435365*^9}, {
   3.630388673208996*^9, 3.630388694866499*^9}, {3.630388730612237*^9, 
   3.630388732914201*^9}, 3.630388778138184*^9, {3.63038881052736*^9, 
   3.630388829202384*^9}, {3.630388955755748*^9, 3.630389038447749*^9}, {
   3.630389106825421*^9, 3.630389132476171*^9}, {3.630389177478092*^9, 
   3.630389287811841*^9}, {3.630389341323417*^9, 3.630389342716626*^9}, {
   3.630389436282416*^9, 3.630389448884775*^9}, {3.630389492213487*^9, 
   3.630389534965439*^9}, {3.630389582322764*^9, 3.630389602531642*^9}, {
   3.630389638000739*^9, 3.630389648571809*^9}, 3.630389679152183*^9, {
   3.630389884437097*^9, 3.630389900780566*^9}, {3.630389973338437*^9, 
   3.63038997606271*^9}, {3.630390007388358*^9, 3.630390042450362*^9}, 
   3.63039101714174*^9, {3.630409823606252*^9, 3.630409824285668*^9}, {
   3.630410862814356*^9, 3.630410881882217*^9}, {3.630410925313276*^9, 
   3.630410933105104*^9}, {3.6304146732237453`*^9, 3.630414679747316*^9}, {
   3.630416111047124*^9, 3.6304161232732687`*^9}, {3.630416229317906*^9, 
   3.63041625007887*^9}, {3.630416506023921*^9, 3.630416581130279*^9}, {
   3.630416957471904*^9, 3.6304169853456087`*^9}, {3.630417021171441*^9, 
   3.630417102311515*^9}, {3.630417136086214*^9, 3.630417152460446*^9}, {
   3.630417264788945*^9, 3.6304172670535583`*^9}, {3.6304187993629*^9, 
   3.630419047244063*^9}, 3.630419158549575*^9, {3.630419382633388*^9, 
   3.630419416521318*^9}, {3.630453866492691*^9, 3.630453885323345*^9}, {
   3.630454382636814*^9, 3.6304543915651083`*^9}, {3.630454434267722*^9, 
   3.630454438204975*^9}, {3.630454516694459*^9, 3.630454528105647*^9}, 
   3.6304546836947823`*^9, {3.630456040235268*^9, 3.630456054982705*^9}, {
   3.630456686966313*^9, 3.630456693813484*^9}, {3.630456827120964*^9, 
   3.6304568515574903`*^9}, {3.630457191121379*^9, 3.630457205757718*^9}, {
   3.6304573739661083`*^9, 3.630457398253991*^9}, {3.630458416029756*^9, 
   3.63045841649681*^9}, {3.6304586331031237`*^9, 3.630458640117593*^9}, 
   3.630504708025806*^9, {3.63050477460327*^9, 3.6305048457205048`*^9}, {
   3.630559050729583*^9, 3.6305591036405973`*^9}, {3.630561311991329*^9, 
   3.630561313444214*^9}, {3.6321372750760803`*^9, 3.632137294562476*^9}, {
   3.632137392831038*^9, 3.632137432403516*^9}, 3.632137465342574*^9, {
   3.632137512145956*^9, 3.6321375135702057`*^9}, {3.6321377991637783`*^9, 
   3.632137897381382*^9}, {3.632139089616729*^9, 3.632139101951776*^9}, 
   3.632139138384727*^9, {3.632141122350223*^9, 3.632141123177332*^9}, {
   3.632141420173427*^9, 3.6321414217924767`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"STEP", " ", "3"}], ":", " ", 
    RowBox[{
     RowBox[{"BROWN", "'"}], "S", " ", "PROJECTION"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"projection", "[", 
      RowBox[{"q0_", ",", "xlist_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"q1", ",", "i", ",", "temp", ",", "qlist"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp", "=", "q0"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"temp", "=", 
         RowBox[{"FactorSquareFreeList", "[", "temp", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"temp", "=", 
         RowBox[{"Times", "@@", 
          RowBox[{"(", 
           RowBox[{"Power", "@@@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", "1"}], "}"}], "&"}], "/@",
               "temp"}], ")"}]}], ")"}]}]}], ";", "   ", 
        RowBox[{"(*", 
         RowBox[{"free", " ", "squares", " ", "in", " ", "q_", "0"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"qlist", "=", 
         RowBox[{"{", "temp", "}"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"Do", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"q1", "=", 
            RowBox[{"FactorSquareFreeList", "[", 
             RowBox[{"Resultant", "[", 
              RowBox[{"temp", ",", 
               RowBox[{"D", "[", 
                RowBox[{"temp", ",", 
                 RowBox[{"xlist", "[", 
                  RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
               RowBox[{"xlist", "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"q1", "=", 
            RowBox[{"Times", "@@", 
             RowBox[{"(", 
              RowBox[{"Power", "@@@", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "1"}], "}"}], "&"}], 
                 "/@", "q1"}], ")"}]}], ")"}]}]}], ";", "   ", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"eliminate", " ", "x_i"}], ",", " ", 
             RowBox[{"free", " ", "squares", " ", "in", " ", "q_", "1"}]}], 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"NumericQ", "[", 
              RowBox[{"q1", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
             RowBox[{"q1", "=", 
              RowBox[{"q1", "/", 
               RowBox[{"q1", "[", 
                RowBox[{"[", "1", "]"}], "]"}]}]}]}], "]"}], ";", "   ", 
           RowBox[{"(*", 
            RowBox[{"eliminate", " ", "constants"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"qlist", ",", "q1"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"temp", "=", "q1"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "xlist", "]"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Return", "[", "qlist", "]"}]}]}], "   ", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"return", " ", "q_", "0"}], ",", 
        RowBox[{"q_", "1"}], ",", 
        RowBox[{"q_", "2"}], ",", "..."}], "*)"}], "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.629331449617921*^9, 3.629331596799843*^9}, {
   3.629331634650818*^9, 3.6293316358914413`*^9}, {3.629331684722518*^9, 
   3.629331690211639*^9}, {3.629331820378893*^9, 3.6293318494024067`*^9}, {
   3.629331880748335*^9, 3.629331887019393*^9}, {3.629331920099128*^9, 
   3.6293319620679607`*^9}, {3.629332004956903*^9, 3.629332023395801*^9}, {
   3.62934251168007*^9, 3.629342550744396*^9}, {3.6293426150089693`*^9, 
   3.6293426281138268`*^9}, {3.629342684377491*^9, 3.629342684737224*^9}, {
   3.629342731928978*^9, 3.629342815369052*^9}, {3.6293429664349823`*^9, 
   3.6293429939695063`*^9}, {3.6293430419147873`*^9, 3.629343093363624*^9}, {
   3.629343132313117*^9, 3.6293432248253098`*^9}, {3.629343267233341*^9, 
   3.629343281329998*^9}, {3.629344920833165*^9, 3.629344983222621*^9}, {
   3.629345039866456*^9, 3.629345112547402*^9}, {3.629345194491063*^9, 
   3.629345263193762*^9}, {3.629345705003955*^9, 3.629345728708446*^9}, {
   3.629345790803501*^9, 3.6293458049653063`*^9}, {3.629346010624508*^9, 
   3.62934603762041*^9}, {3.629346146789021*^9, 3.629346172289468*^9}, {
   3.629346272898831*^9, 3.629346337668703*^9}, {3.629346446270685*^9, 
   3.629346446975156*^9}, {3.629348157077592*^9, 3.62934815865982*^9}, {
   3.629349968299108*^9, 3.6293499916129*^9}, {3.6293500353540773`*^9, 
   3.62935006748428*^9}, {3.629350245095447*^9, 3.629350245589198*^9}, {
   3.629350323400358*^9, 3.62935035071062*^9}, {3.629350398325799*^9, 
   3.62935044625467*^9}, {3.6293509569038877`*^9, 3.6293509729601517`*^9}, {
   3.629351013342106*^9, 3.6293510296610727`*^9}, {3.6293510730554237`*^9, 
   3.6293510870955687`*^9}, {3.6293511313038473`*^9, 3.6293511522959623`*^9}, 
   3.629351191764673*^9, 3.629352280950378*^9, {3.629354791960821*^9, 
   3.6293548973323393`*^9}, {3.629354947794376*^9, 3.629354958314506*^9}, {
   3.6293550080818653`*^9, 3.629355019200163*^9}, 3.629362000527432*^9, {
   3.6295368935438547`*^9, 3.6295369072603188`*^9}, {3.629549033125835*^9, 
   3.6295490923901663`*^9}, {3.629870190298773*^9, 3.62987019137088*^9}, {
   3.630036873807371*^9, 3.630036924338429*^9}, {3.630037015098407*^9, 
   3.630037028799931*^9}, 3.630059412367695*^9, {3.6302057398657703`*^9, 
   3.630205809149309*^9}, 3.630278726130356*^9, {3.630288282126039*^9, 
   3.630288295552429*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"STEP", " ", "4"}], ":", " ", 
    RowBox[{
    "REAL", " ", "ROOTS", " ", "ISOLATION", " ", "BASED", " ", "ON", " ", 
     RowBox[{"ROLLE", "'"}], "S", " ", "THEOREM"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"peIsolate", "[", 
      RowBox[{"slist_", ",", "s_", ",", "t_", ",", "interval_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "llist", ",", "templist", ",", "tempinterval", ",", "ft", ",", "dft", 
         ",", "a", ",", "b", ",", "h", ",", "i", ",", "j", ",", "k", ",", 
         "betaj", ",", "alphaj1", ",", "betam", ",", "alpha1"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"a", "=", 
         RowBox[{"Min", "[", "interval", "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"b", "=", 
         RowBox[{"Max", "[", "interval", "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"llist", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"s", "==", 
           RowBox[{"Length", "[", "slist", "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"h", "=", 
             RowBox[{"Which", "[", 
              RowBox[{
               RowBox[{"PolynomialQ", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"List", "@@", 
                    RowBox[{"slist", "[", 
                    RowBox[{"[", "s", "]"}], "]"}]}], ")"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", "t"}], "]"}], ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"List", "@@", 
                  RowBox[{"slist", "[", 
                   RowBox[{"[", "s", "]"}], "]"}]}], ")"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{"PolynomialQ", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"List", "@@", 
                    RowBox[{"slist", "[", 
                    RowBox[{"[", "s", "]"}], "]"}]}], ")"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", "t"}], "]"}], ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"List", "@@", 
                  RowBox[{"slist", "[", 
                   RowBox[{"[", "s", "]"}], "]"}]}], ")"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], ";"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"h", "=", 
            RowBox[{"slist", "[", 
             RowBox[{"[", "s", "]"}], "]"}]}], ";", "   ", 
           RowBox[{"(*", 
            RowBox[{
            "h", " ", "is", " ", "a", " ", "polynomial", " ", "guaranteed", 
             " ", "by", " ", "dSequense"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Print", "[", "h", "]"}], ";"}], "*)"}], 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"CountRoots", "[", 
               RowBox[{"h", ",", 
                RowBox[{"{", 
                 RowBox[{"t", ",", "a", ",", "b"}], "}"}]}], "]"}], 
              "\[Equal]", "0"}], ",", 
             RowBox[{"llist", "=", 
              RowBox[{"{", "}"}]}], ",", "   ", 
             RowBox[{"(*", 
              RowBox[{"when", " ", "h", " ", "has", " ", "no", " ", "root"}], 
              "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"llist", "=", 
               RowBox[{"t", "/.", 
                RowBox[{"Solve", "[", 
                 RowBox[{
                  RowBox[{"h", "\[Equal]", "0"}], ",", "t", ",", "Reals"}], 
                 "]"}]}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"For", "[", 
               RowBox[{
                RowBox[{"i", "=", "1"}], ",", 
                RowBox[{"i", "\[LessEqual]", 
                 RowBox[{"Length", "[", "llist", "]"}]}], ",", 
                RowBox[{"i", "++"}], ",", "   ", 
                RowBox[{"(*", 
                 RowBox[{
                 "stretch", " ", "a", " ", "tiny", " ", "interval", " ", 
                  "for", " ", "each", " ", "root"}], "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"(*", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"llist", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "\[LessEqual]", "0"}], 
                   ",", 
                   RowBox[{"llist", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"llist", ",", "i"}], "]"}]}], ","}], "   ", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{"skip", " ", "such", " ", "t"}], "\[LessEqual]", 
                    "0"}], "*)"}]}], "*)"}], "\[IndentingNewLine]", 
                RowBox[{"llist", "=", 
                 RowBox[{"ReplacePart", "[", 
                  RowBox[{"llist", ",", 
                   RowBox[{"i", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"llist", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "-", "0.0001"}], ",", 
                    RowBox[{
                    RowBox[{"llist", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", "0.0001"}]}], 
                    "}"}]}]}], "]"}]}]}], "\[IndentingNewLine]", 
               RowBox[{"(*", "]", "*)"}], "\[IndentingNewLine]", "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"llist", "=", 
               RowBox[{"List", "@@", 
                RowBox[{"(", 
                 RowBox[{"IntervalIntersection", "[", 
                  RowBox[{
                   RowBox[{"Interval", "@@", 
                    RowBox[{"(", "llist", ")"}]}], ",", "interval"}], "]"}], 
                 ")"}]}]}]}]}], "\[IndentingNewLine]", "]"}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"templist", "=", 
            RowBox[{"peIsolate", "[", 
             RowBox[{"slist", ",", 
              RowBox[{"s", "+", "1"}], ",", "t", ",", "interval"}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Print", "[", "templist", "]"}], ";"}], "*)"}], 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"ft", "=", 
            RowBox[{"slist", "[", 
             RowBox[{"[", "s", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"dft", "=", 
            RowBox[{"slist", "[", 
             RowBox[{"[", 
              RowBox[{"s", "+", "1"}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{
              "\"\<ft: \>\"", ",", "ft", ",", "\"\<dft:  \>\"", ",", "dft"}], 
              "]"}], ";"}], "*)"}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"templist", "\[Equal]", 
              RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"ft", "/.", 
                    RowBox[{"{", 
                    RowBox[{"t", "->", "a"}], "}"}]}], ")"}], 
                  RowBox[{"(", 
                   RowBox[{"ft", "/.", 
                    RowBox[{"{", 
                    RowBox[{"t", "\[Rule]", "b"}], "}"}]}], ")"}]}], "<", 
                 "0"}], ",", 
                RowBox[{"llist", "=", 
                 RowBox[{"{", 
                  RowBox[{"{", 
                   RowBox[{"a", ",", "b"}], "}"}], "}"}]}], ",", 
                RowBox[{"llist", "=", 
                 RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"s", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"llist", "\[NotEqual]", 
                    RowBox[{"{", "}"}]}], "&&", 
                   RowBox[{
                    RowBox[{"llist", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "\[NotEqual]", 
                    RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"llist", "=", 
                   RowBox[{"ReplacePart", "[", 
                    RowBox[{"llist", ",", 
                    RowBox[{"1", "->", 
                    RowBox[{"refineF", "[", 
                    RowBox[{"ft", ",", 
                    RowBox[{"llist", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "t", ",", "0.25"}], 
                    "]"}]}]}], "]"}]}]}], 
                 RowBox[{"(*", 
                  RowBox[{"another", " ", "refine", " ", "here"}], "*)"}], 
                 "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}],
               ";", "\[IndentingNewLine]", 
              RowBox[{"Return", "[", "llist", "]"}]}]}], "]"}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"tempinterval", "=", 
               RowBox[{"Interval", "[", 
                RowBox[{"templist", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"tempinterval", "=", 
               RowBox[{"refine", "[", 
                RowBox[{"ft", ",", "dft", ",", "tempinterval", ",", "t"}], 
                "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"Print", "[", 
                 RowBox[{
                 "ft", ",", "\"\<   \>\"", ",", "dft", ",", "\"\<   \>\"", 
                  ",", "tempinterval"}], "]"}], ";"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"templist", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "=", 
               RowBox[{"List", "[", 
                RowBox[{
                 RowBox[{"Min", "[", "tempinterval", "]"}], ",", 
                 RowBox[{"Max", "[", "tempinterval", "]"}]}], "]"}]}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", 
               RowBox[{"Length", "[", "templist", "]"}]}], "}"}]}], "]"}], 
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"templist", "=", 
            RowBox[{"Sort", "[", "templist", "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"Do", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"betaj", "=", 
               RowBox[{"Max", "[", 
                RowBox[{"templist", "[", 
                 RowBox[{"[", "j", "]"}], "]"}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"alphaj1", "=", 
               RowBox[{"Min", "[", 
                RowBox[{"templist", "[", 
                 RowBox[{"[", 
                  RowBox[{"j", "+", "1"}], "]"}], "]"}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"ft", "/.", 
                    RowBox[{"{", 
                    RowBox[{"t", "->", "betaj"}], "}"}]}], ")"}], 
                  RowBox[{"(", 
                   RowBox[{"ft", "/.", 
                    RowBox[{"{", 
                    RowBox[{"t", "->", "alphaj1"}], "}"}]}], ")"}]}], "<", 
                 "0"}], ",", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"llist", ",", 
                  RowBox[{"List", "[", 
                   RowBox[{"betaj", ",", "alphaj1"}], "]"}]}], "]"}]}], 
               "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", 
               RowBox[{
                RowBox[{"Length", "[", "templist", "]"}], "-", "2"}]}], 
              "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"alpha1", "=", 
            RowBox[{"Min", "[", 
             RowBox[{"templist", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"betam", "=", 
            RowBox[{"Max", "[", 
             RowBox[{"templist", "[", 
              RowBox[{"[", 
               RowBox[{"-", "1"}], "]"}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"a", "<", "alpha1"}], "&&", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"ft", "/.", 
                  RowBox[{"{", 
                   RowBox[{"t", "->", "a"}], "}"}]}], ")"}], 
                RowBox[{"(", 
                 RowBox[{"ft", "/.", 
                  RowBox[{"{", 
                   RowBox[{"t", "->", "alpha1"}], "}"}]}], ")"}]}], "<", 
               "0"}]}], ",", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"llist", ",", 
               RowBox[{"List", "[", 
                RowBox[{"a", ",", "alpha1"}], "]"}]}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"betam", "<", "b"}], "&&", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"ft", "/.", 
                  RowBox[{"{", 
                   RowBox[{"t", "->", "betam"}], "}"}]}], ")"}], 
                RowBox[{"(", 
                 RowBox[{"ft", "/.", 
                  RowBox[{"{", 
                   RowBox[{"t", "->", "b"}], "}"}]}], ")"}]}], "<", "0"}]}], 
             ",", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"llist", ",", 
               RowBox[{"List", "[", 
                RowBox[{"betam", ",", "b"}], "]"}]}], "]"}]}], "]"}]}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{"s", ",", "\"\< \>\"", ",", "slist"}], "]"}], ";"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"s", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"k", "=", "1"}], ",", 
            RowBox[{"k", "\[LessEqual]", 
             RowBox[{"Length", "[", "llist", "]"}]}], ",", 
            RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"llist", "\[NotEqual]", 
                RowBox[{"{", "}"}]}], "&&", 
               RowBox[{
                RowBox[{"llist", "[", 
                 RowBox[{"[", "k", "]"}], "]"}], "\[NotEqual]", 
                RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
              RowBox[{"llist", "=", 
               RowBox[{"ReplacePart", "[", 
                RowBox[{"llist", ",", 
                 RowBox[{"k", "->", 
                  RowBox[{"refineF", "[", 
                   RowBox[{"ft", ",", 
                    RowBox[{"llist", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], ",", "t", ",", "0.25"}], 
                   "]"}]}]}], "]"}]}]}], 
             RowBox[{"(*", 
              RowBox[{"another", " ", "refine", " ", "here"}], "*)"}], 
             "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"Return", "[", "llist", "]"}]}]}], "   ", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"return", " ", "llist"}], ",", " ", 
        RowBox[{
         RowBox[{
         "a", " ", "real", " ", "root", " ", "isolation", " ", "of", " ", 
          "s_", "0"}], " ", "=", " ", 
         RowBox[{"0", " ", "in", " ", 
          RowBox[{"(", 
           RowBox[{"a", ",", "b"}], ")"}]}]}]}], "*)"}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.6298702388995667`*^9, 3.629870260907765*^9}, {
   3.6298702982019*^9, 3.629870332298883*^9}, {3.6298704009173737`*^9, 
   3.629870402979374*^9}, {3.629870436139737*^9, 3.629870472869712*^9}, {
   3.629870513187813*^9, 3.629870540908802*^9}, 3.62987088604541*^9, {
   3.629871024836515*^9, 3.629871043701624*^9}, {3.6298711917653513`*^9, 
   3.6298713121846447`*^9}, {3.629871460526031*^9, 3.629871474365753*^9}, {
   3.629871943862913*^9, 3.629871993854035*^9}, {3.62987208711094*^9, 
   3.629872097597069*^9}, {3.6298721636701937`*^9, 3.629872195803521*^9}, {
   3.629872270230364*^9, 3.629872327053112*^9}, {3.62987281587022*^9, 
   3.629872849493854*^9}, 3.62987323897444*^9, {3.629878954820524*^9, 
   3.6298789779378643`*^9}, {3.62987904209827*^9, 3.6298790903384943`*^9}, {
   3.629879255891881*^9, 3.629879439233418*^9}, 3.629879498624626*^9, {
   3.629879688705305*^9, 3.629879717743268*^9}, {3.629879875534772*^9, 
   3.629879971801156*^9}, {3.629880037448125*^9, 3.629880134902442*^9}, {
   3.629880167950327*^9, 3.629880200421658*^9}, {3.629880243679875*^9, 
   3.629880248551423*^9}, {3.629880596565654*^9, 3.629880596948903*^9}, {
   3.629880637658146*^9, 3.62988064496273*^9}, {3.629880720820895*^9, 
   3.629880738644476*^9}, {3.629880772063384*^9, 3.629880818820063*^9}, {
   3.6298811451720543`*^9, 3.629881156091906*^9}, {3.629881243757395*^9, 
   3.629881264773863*^9}, 3.6298813011816273`*^9, {3.6298814839279337`*^9, 
   3.629881493538488*^9}, 3.629881555510956*^9, {3.629881586720042*^9, 
   3.62988161419003*^9}, {3.629881679768598*^9, 3.6298816813409023`*^9}, {
   3.629881714619857*^9, 3.6298817748610077`*^9}, {3.6298818189696074`*^9, 
   3.629881883757856*^9}, {3.629882050020562*^9, 3.629882053915988*^9}, 
   3.6298821137050133`*^9, {3.6298821478544416`*^9, 3.629882201672695*^9}, {
   3.629882242571815*^9, 3.629882368336668*^9}, {3.629882408888638*^9, 
   3.629882411000688*^9}, {3.629882639408786*^9, 3.62988266572668*^9}, {
   3.629882953375885*^9, 3.629882995583799*^9}, {3.6298830417217627`*^9, 
   3.629883071465713*^9}, {3.629883125462386*^9, 3.62988316712043*^9}, {
   3.6298832047783213`*^9, 3.6298832283990707`*^9}, {3.6298833001785994`*^9, 
   3.62988332865648*^9}, 3.6298833876287413`*^9, 3.6298834191217957`*^9, {
   3.629883571339834*^9, 3.629883580123567*^9}, {3.629883883767853*^9, 
   3.6298838847356453`*^9}, {3.6298839319438677`*^9, 
   3.6298839504897614`*^9}, {3.629883988098366*^9, 3.629884012575151*^9}, {
   3.629884048480542*^9, 3.6298840781021214`*^9}, {3.629884122746584*^9, 
   3.629884145947669*^9}, {3.629884232052451*^9, 3.629884235104062*^9}, {
   3.629884265346607*^9, 3.629884371581271*^9}, {3.629884717759122*^9, 
   3.629884778421344*^9}, {3.629884808558401*^9, 3.629884845746995*^9}, {
   3.6298849040781517`*^9, 3.6298849191012487`*^9}, {3.629885309666947*^9, 
   3.629885364185812*^9}, {3.629885548831911*^9, 3.6298855506281033`*^9}, {
   3.62988575602908*^9, 3.62988595374909*^9}, {3.629886058219768*^9, 
   3.6298860719732647`*^9}, {3.629886133053142*^9, 3.6298861479336767`*^9}, {
   3.62988620646926*^9, 3.629886227907419*^9}, {3.629886281453961*^9, 
   3.629886287349125*^9}, {3.6298863766321163`*^9, 3.629886386841353*^9}, {
   3.629886697225398*^9, 3.629886700709498*^9}, {3.629886888832958*^9, 
   3.629886918308929*^9}, {3.629886967188126*^9, 3.6298870337089787`*^9}, {
   3.629887064956829*^9, 3.629887090470253*^9}, {3.629887184017344*^9, 
   3.6298872427790623`*^9}, {3.6298872749007597`*^9, 3.62988729287796*^9}, {
   3.629887327617916*^9, 3.62988747745512*^9}, {3.629887509718753*^9, 
   3.629887567616544*^9}, {3.629887751895155*^9, 3.6298878215817957`*^9}, {
   3.629887879741577*^9, 3.6298879497525883`*^9}, {3.629887983563547*^9, 
   3.6298881120519323`*^9}, {3.629888147785881*^9, 3.629888149742709*^9}, {
   3.629936016455117*^9, 3.6299360285721893`*^9}, 3.630059444008769*^9, {
   3.630059623959882*^9, 3.630059634861617*^9}, {3.630118520399205*^9, 
   3.630118543165915*^9}, 3.630119348527218*^9, {3.630218556336025*^9, 
   3.630218641235715*^9}, {3.6302214706080236`*^9, 3.630221497499769*^9}, {
   3.630221557206093*^9, 3.630221583431136*^9}, 3.630221620882053*^9, {
   3.630221778785459*^9, 3.630221821254156*^9}, {3.630221869289555*^9, 
   3.630221946825966*^9}, {3.630222105095293*^9, 3.6302221304434013`*^9}, {
   3.63022219076539*^9, 3.630222208550646*^9}, {3.630222349559864*^9, 
   3.6302223574678*^9}, 3.630222453359494*^9, {3.6302300766822987`*^9, 
   3.630230107068709*^9}, {3.630230242260702*^9, 3.6302302713302603`*^9}, {
   3.630230440118122*^9, 3.6302304446792393`*^9}, {3.630230752066366*^9, 
   3.630230785165655*^9}, {3.63023110281135*^9, 3.630231133886393*^9}, {
   3.630232452483712*^9, 3.630232464179967*^9}, {3.6302325281419992`*^9, 
   3.6302325347297163`*^9}, {3.630232800290868*^9, 3.630232981084881*^9}, {
   3.630233165500923*^9, 3.630233202852602*^9}, {3.6302332339186296`*^9, 
   3.630233236717058*^9}, {3.630233302623061*^9, 3.6302333066405993`*^9}, {
   3.630233904788945*^9, 3.630233909358492*^9}, {3.630234168743561*^9, 
   3.630234172156568*^9}, {3.6302342153598137`*^9, 3.630234220732234*^9}, {
   3.6302344110411673`*^9, 3.630234479686318*^9}, {3.630235272599402*^9, 
   3.6302353248601303`*^9}, {3.630235385776235*^9, 3.6302353990285*^9}, {
   3.630235429963023*^9, 3.630235464941855*^9}, {3.6302368171473923`*^9, 
   3.630236822341795*^9}, {3.6302368656058607`*^9, 3.630236887702168*^9}, {
   3.630238755337512*^9, 3.630238755503389*^9}, {3.630238984106099*^9, 
   3.630238994857479*^9}, {3.630239057591043*^9, 3.630239171627849*^9}, {
   3.630239224343424*^9, 3.630239265074321*^9}, {3.630239764201255*^9, 
   3.630239768222192*^9}, {3.63024214326374*^9, 3.630242173643985*^9}, {
   3.630242312040257*^9, 3.630242313870215*^9}, {3.630242350882537*^9, 
   3.630242388021994*^9}, {3.630242463937011*^9, 3.630242487146267*^9}, {
   3.630242769682138*^9, 3.630242839016589*^9}, {3.630242876930781*^9, 
   3.630242903283421*^9}, {3.630242936364933*^9, 3.630242978435972*^9}, {
   3.630243264863872*^9, 3.630243330255413*^9}, {3.630243360650174*^9, 
   3.630243492570238*^9}, {3.630243553689803*^9, 3.630243588793933*^9}, {
   3.6302441214241467`*^9, 3.630244122926074*^9}, {3.630287236133176*^9, 
   3.6302872539174757`*^9}, {3.63028734159445*^9, 3.6302873606215763`*^9}, {
   3.630288182356179*^9, 3.63028818822147*^9}, {3.6302883188580027`*^9, 
   3.630288320460218*^9}, {3.6303258255300426`*^9, 3.6303258258973627`*^9}, 
   3.630325889621719*^9, {3.630325975047902*^9, 3.630325975498108*^9}, {
   3.6303266394939423`*^9, 3.630326642574099*^9}, {3.630326700824725*^9, 
   3.630326735506135*^9}, {3.6303268479558268`*^9, 3.6303268677223263`*^9}, {
   3.630326984829219*^9, 3.630327045996608*^9}, {3.6303270847012873`*^9, 
   3.630327126972789*^9}, {3.6303281154854918`*^9, 3.630328119798444*^9}, {
   3.630454750557743*^9, 3.630454753053711*^9}, {3.630454841576735*^9, 
   3.630454909860326*^9}, {3.6304549620832376`*^9, 3.630454963130122*^9}, {
   3.630454995706305*^9, 3.6304550296661654`*^9}, {3.630455118104823*^9, 
   3.630455123878932*^9}, {3.630455166056994*^9, 3.630455286577795*^9}, 
   3.630455539153673*^9, {3.630455695217551*^9, 3.630455700954356*^9}, {
   3.6304562148428583`*^9, 3.630456216935543*^9}, {3.630456660804133*^9, 
   3.630456675376761*^9}, {3.6304569653714113`*^9, 3.630456984551571*^9}, {
   3.630457451352141*^9, 3.630457495568857*^9}, {3.63045801836033*^9, 
   3.630458050378189*^9}, {3.6304580906557617`*^9, 3.630458118012926*^9}, 
   3.630458189349209*^9, {3.6304582862310247`*^9, 3.630458322443119*^9}, {
   3.630458363697193*^9, 3.63045837059661*^9}, 3.630458472674719*^9, {
   3.630458730885701*^9, 3.630458734868022*^9}, {3.630458789089093*^9, 
   3.6304588229858217`*^9}, {3.630459001995064*^9, 3.630459094657445*^9}, {
   3.6305050610180492`*^9, 3.63050506948987*^9}, {3.630505304837809*^9, 
   3.630505309302758*^9}, {3.630505541539522*^9, 3.63050560050637*^9}, {
   3.63055888841486*^9, 3.630558924943438*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "generate", " ", "a", " ", "sequence", " ", "of", " ", "derivatives"}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"dSequence", "[", 
      RowBox[{"qn_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "slist", ",", "s0", ",", "s1", ",", "f0", ",", "f1", ",", "tempf1", 
         ",", "i"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"s0", "=", "qn"}], ";", "\[IndentingNewLine]", 
        RowBox[{"f0", "=", "0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"k", "=", "0"}], ";"}], "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"s0", "=", 
         RowBox[{"Collect", "[", 
          RowBox[{"s0", ",", 
           RowBox[{"E", "^", "_"}]}], "]"}]}], ";", "   ", 
        RowBox[{"(*", 
         RowBox[{
         "rerange", " ", "PEF", " ", "according", " ", "to", " ", 
          "exponential", " ", "degrees"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"slist", "=", 
         RowBox[{"{", "s0", "}"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"While", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"PolynomialQ", "[", 
            RowBox[{"s0", ",", "t"}], "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"Head", "[", "s0", "]"}], "\[Equal]", "Plus"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"Print", "[", 
             RowBox[{"Head", "[", "s0", "]"}], "]"}], ";"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"k", "++"}], ";"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"len", "=", 
               RowBox[{"Count", "[", 
                RowBox[{
                 RowBox[{"List", "@@", 
                  RowBox[{"Simplify", "[", 
                   RowBox[{"D", "[", 
                    RowBox[{"s0", ",", "t"}], "]"}], "]"}]}], ",", 
                 RowBox[{
                  RowBox[{"v_.", 
                   RowBox[{"E", "^", 
                    RowBox[{"(", "u_", ")"}]}], "m_."}], "/;", 
                  RowBox[{
                   RowBox[{"PolynomialQ", "[", 
                    RowBox[{"u", ",", "t"}], "]"}], "&&", 
                   RowBox[{"PolynomialQ", "[", 
                    RowBox[{"v", ",", "t"}], "]"}], "&&", 
                   RowBox[{"PolynomialQ", "[", 
                    RowBox[{"m", ",", "t"}], "]"}], "&&", 
                   RowBox[{"!", 
                    RowBox[{"NumericQ", "[", "u", "]"}]}]}]}]}], "]"}]}], 
              ")"}], ">", "1"}], ","}], "   ", 
           RowBox[{"(*", 
            RowBox[{
            "loop", " ", "until", " ", "exactly", " ", "one", " ", 
             "exponention", " ", "left"}], "*)"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"Print", "[", "len", "]"}], ";"}], "*)"}], 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"Head", "[", "s0", "]"}], "===", "Power"}], "||", 
               RowBox[{
                RowBox[{"Head", "[", "s0", "]"}], "===", "Times"}]}], ")"}], 
             ",", 
             RowBox[{
              RowBox[{"f0", "=", "0"}], ";", 
              RowBox[{"f1", "=", "s0"}]}], ",", "   ", 
             RowBox[{"(*", 
              RowBox[{
              "set", " ", "f0", " ", "to", " ", "0", " ", "when", " ", "a", 
               " ", "single", " ", "exponention", " ", "enters", " ", "in", 
               " ", "the", " ", "first", " ", "loop"}], "*)"}], 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"f0", "=", 
               RowBox[{"Plus", "@@", 
                RowBox[{"(", 
                 RowBox[{"Select", "[", 
                  RowBox[{
                   RowBox[{"List", "@@", 
                    RowBox[{"(", "s0", ")"}]}], ",", 
                   RowBox[{
                    RowBox[{"PolynomialQ", "[", 
                    RowBox[{"#", ",", "t"}], "]"}], "&"}]}], "]"}], ")"}]}]}],
               ";", "   ", "\[IndentingNewLine]", 
              RowBox[{"Do", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"!", 
                   RowBox[{"PolynomialQ", "[", 
                    RowBox[{
                    RowBox[{"s0", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", "t"}], "]"}]}], ",", 
                  
                  RowBox[{
                   RowBox[{"f1", "=", 
                    RowBox[{"s0", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], ";", 
                   RowBox[{"Break", "[", "]"}]}]}], "]"}], ",", "   ", 
                RowBox[{"(*", 
                 RowBox[{"record", " ", 
                  RowBox[{"f1", ":", " ", 
                   RowBox[{"the", " ", "first", " ", "exponention"}]}]}], 
                 "*)"}], "   ", 
                RowBox[{"(*", 
                 RowBox[{
                 "constants", " ", "are", " ", "polynomials", " ", "too"}], 
                 "*)"}], "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "1", ",", 
                  RowBox[{"Length", "[", "s0", "]"}]}], "}"}]}], "]"}]}]}], 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{"Do", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"PolynomialQ", "[", 
                   RowBox[{
                    RowBox[{"s0", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "i"}], "]"}], "]"}], ",", "t"}], "]"}], ",", 
                  
                  RowBox[{"f0", "+=", 
                   RowBox[{"s0", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "i"}], "]"}], "]"}]}], ",", 
                  RowBox[{"Break", "[", "]"}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "1", ",", 
                  RowBox[{"Length", "[", "s0", "]"}]}], "}"}]}], "]"}], ";"}],
              "   ", 
             RowBox[{"(*", 
              RowBox[{
              "construct", " ", "f_", "0", " ", "which", " ", "is", " ", 
               "exponential", " ", "free"}], "*)"}], "\[IndentingNewLine]", 
             "*)"}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{"\"\<f0: \>\"", ",", "f0"}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"Print", "[", 
              RowBox[{"\"\<f1: \>\"", ",", "f1"}], "]"}], ";"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"f1", "=", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"tempf1", "=", 
                 RowBox[{"Select", "[", 
                  RowBox[{
                   RowBox[{"List", "@@", 
                    RowBox[{"(", "f1", ")"}]}], ",", 
                   RowBox[{
                    RowBox[{"!", 
                    RowBox[{"PolynomialQ", "[", 
                    RowBox[{"#", ",", "t"}], "]"}]}], "&"}]}], "]"}]}], ")"}],
                "\[Equal]", 
               RowBox[{"{", "}"}]}], ",", "f1", ",", 
              RowBox[{"tempf1", "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], ";", "   ", 
           RowBox[{"(*", 
            RowBox[{"extract", " ", "single", " ", "exponention"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{"\"\<f0: \>\"", ",", "f0"}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"Print", "[", 
              RowBox[{"\"\<f1: \>\"", ",", "f1"}], "]"}], ";"}], "*)"}], 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"v1", "=", 
              RowBox[{"D", "[", 
               RowBox[{
                RowBox[{"Log", "[", "f1", "]"}], ",", "t"}], "]"}]}], ";"}], 
            "   ", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{"Coefficient", "[", 
               RowBox[{
                RowBox[{"Log", "[", "f1", "]"}], ",", "t"}], "]"}], ";"}], 
             "*)"}], "  ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"s1", "=", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"D", "[", 
                  RowBox[{"f0", ",", "t"}], "]"}], "\[NotEqual]", "0"}], ",", 
                
                RowBox[{"D", "[", 
                 RowBox[{"s0", ",", "t"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"D", "[", 
                  RowBox[{"s0", ",", "t"}], "]"}], "/", "f1"}]}], "]"}]}], 
             ";"}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"s1", "=", 
            RowBox[{"D", "[", 
             RowBox[{"s0", ",", "t"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"D", "[", 
               RowBox[{"f0", ",", "t"}], "]"}], "\[Equal]", "0"}], ",", 
             RowBox[{"s1", "=", 
              RowBox[{"s1", "/", "f1"}]}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{"\"\<s1:  \>\"", ",", "s1"}], "]"}], ";"}], "*)"}], 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"s1", "=", 
            RowBox[{"Collect", "[", 
             RowBox[{"s1", ",", 
              RowBox[{"E", "^", "_"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"AppendTo", "[", 
            RowBox[{"slist", ",", "s1"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{"k", ",", "\"\< \>\""}], "]"}], ";"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"s0", "=", "s1"}]}]}], "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"Print", "[", "slist", "]"}], ";"}], "*)"}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"AppendTo", "[", 
           RowBox[{"slist", ",", 
            RowBox[{"Simplify", "[", 
             RowBox[{"D", "[", 
              RowBox[{"s0", ",", "t"}], "]"}], "]"}]}], "]"}], ";"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"Print", "[", "k", "]"}], ";"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"Print", "[", "slist", "]"}], ";"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"Return", "[", "slist", "]"}]}]}], "   ", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"return", " ", "s_", "0"}], ",", 
        RowBox[{"s_", "1"}], ",", 
        RowBox[{"s_", "2"}], ",", "..."}], "*)"}], "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.62935217506168*^9, 3.629352188104354*^9}, {
   3.62935223455266*^9, 3.629352298056768*^9}, {3.629449171897911*^9, 
   3.6294492278487186`*^9}, {3.629449273344644*^9, 3.6294493126813183`*^9}, {
   3.6294494169445667`*^9, 3.6294494595856857`*^9}, {3.6294495587370787`*^9, 
   3.629449617089246*^9}, {3.6295366758843946`*^9, 3.629536740309476*^9}, {
   3.629536788556682*^9, 3.629536805715962*^9}, {3.6295368451017923`*^9, 
   3.6295368477574387`*^9}, 3.6295369185580072`*^9, {3.6295369542780533`*^9, 
   3.629537025406768*^9}, {3.629537097143126*^9, 3.629537163662671*^9}, {
   3.62953726240156*^9, 3.629537279975368*^9}, {3.629537401345853*^9, 
   3.629537470608286*^9}, {3.6295375237357693`*^9, 3.629537728121449*^9}, {
   3.629540292728415*^9, 3.62954035196937*^9}, {3.629540397963933*^9, 
   3.629540415397098*^9}, {3.629540647241733*^9, 3.6295407625825253`*^9}, {
   3.629541061600431*^9, 3.6295410693453407`*^9}, {3.629541499926456*^9, 
   3.629541542142612*^9}, {3.629541668861903*^9, 3.629541711787146*^9}, 
   3.629541745887759*^9, {3.629541798736278*^9, 3.629541859672159*^9}, {
   3.629541921906798*^9, 3.6295420572669277`*^9}, {3.629542606172246*^9, 
   3.629542631059895*^9}, {3.629542662832961*^9, 3.629542664203723*^9}, {
   3.629542742093707*^9, 3.6295427436208477`*^9}, {3.6295428151239*^9, 
   3.629542815988559*^9}, {3.629542893339724*^9, 3.629542893616385*^9}, {
   3.629542941306922*^9, 3.6295430578897343`*^9}, 3.6295431358488894`*^9, {
   3.629543174563711*^9, 3.629543222655427*^9}, {3.629543270561061*^9, 
   3.6295434260817957`*^9}, {3.629543649367876*^9, 3.629543693753976*^9}, {
   3.6295448208420687`*^9, 3.629544829447569*^9}, {3.629544911664019*^9, 
   3.6295449118171387`*^9}, {3.629544994100224*^9, 3.629545006068866*^9}, {
   3.6295482249231*^9, 3.629548276802062*^9}, {3.629548382323118*^9, 
   3.62954838699938*^9}, {3.62954852514293*^9, 3.629548545072878*^9}, {
   3.629548642251628*^9, 3.629548714319612*^9}, {3.629548784062624*^9, 
   3.629548808765368*^9}, {3.629548846907487*^9, 3.629548878258752*^9}, {
   3.629548909819908*^9, 3.629548949637704*^9}, {3.629549069748217*^9, 
   3.629549127939719*^9}, {3.629549173593688*^9, 3.629549277938281*^9}, {
   3.629549318943474*^9, 3.62954934260585*^9}, {3.6295495639660873`*^9, 
   3.629549645958873*^9}, {3.62954970459242*^9, 3.629549763373911*^9}, {
   3.6295498702571707`*^9, 3.629549895317668*^9}, {3.629550025660372*^9, 
   3.629550026943905*^9}, {3.629550175017777*^9, 3.629550192652272*^9}, {
   3.6295502274863997`*^9, 3.629550270350614*^9}, {3.62955043134128*^9, 
   3.6295504354171*^9}, {3.629550486574871*^9, 3.62955051541261*^9}, {
   3.629550583097781*^9, 3.6295505835373697`*^9}, {3.6295506720484543`*^9, 
   3.6295506750190496`*^9}, {3.629601773719137*^9, 3.629601785078126*^9}, {
   3.629601859158593*^9, 3.62960187641742*^9}, {3.629601922387549*^9, 
   3.629601951327795*^9}, {3.6296021618777323`*^9, 3.6296021713813477`*^9}, {
   3.629602334863924*^9, 3.6296023393144197`*^9}, {3.629602414022636*^9, 
   3.629602420794341*^9}, {3.62960249027453*^9, 3.629602491250451*^9}, {
   3.629602540998951*^9, 3.6296026012552233`*^9}, {3.629602652395166*^9, 
   3.629602653126004*^9}, {3.629602694369285*^9, 3.629602718583489*^9}, {
   3.629602769271077*^9, 3.629602771887021*^9}, {3.62960283499083*^9, 
   3.629602839783095*^9}, {3.629602896623756*^9, 3.629602917672624*^9}, {
   3.6296029610551777`*^9, 3.629602963254757*^9}, 3.629603034503133*^9, {
   3.629603101143886*^9, 3.629603101627865*^9}, 3.6296031321946697`*^9, {
   3.6296036795437393`*^9, 3.6296036867990723`*^9}, {3.62960372799481*^9, 
   3.629603728360238*^9}, 3.6296037629514217`*^9, {3.6296038448014517`*^9, 
   3.629603851055797*^9}, {3.629603886527215*^9, 3.62960392338416*^9}, {
   3.62960440265619*^9, 3.629604434826921*^9}, {3.629604796618279*^9, 
   3.6296048239767838`*^9}, {3.629607128259163*^9, 3.6296071617477617`*^9}, {
   3.6296072700344152`*^9, 3.629607275112431*^9}, {3.6296073421125307`*^9, 
   3.6296075309240713`*^9}, {3.629609070600465*^9, 3.629609115426435*^9}, {
   3.62960917916434*^9, 3.6296091856316757`*^9}, {3.629609279999852*^9, 
   3.6296092803782787`*^9}, {3.629609480447815*^9, 3.6296095033102303`*^9}, {
   3.629609561709688*^9, 3.629609566103615*^9}, {3.629609640431726*^9, 
   3.6296096582632217`*^9}, {3.629609766371522*^9, 3.629609818486897*^9}, 
   3.629609878374056*^9, 3.629693864793289*^9, {3.629869756460596*^9, 
   3.6298698051957617`*^9}, {3.629869875118882*^9, 3.62986991653146*^9}, {
   3.629869982878977*^9, 3.6298700209211283`*^9}, {3.6298700737202253`*^9, 
   3.629870087909854*^9}, {3.629870120795765*^9, 3.629870135986372*^9}, {
   3.629870176516635*^9, 3.629870178585127*^9}, 3.629870213222516*^9, {
   3.630023582047052*^9, 3.6300236028969393`*^9}, {3.630023730247583*^9, 
   3.630023746430181*^9}, {3.630028161865972*^9, 3.6300282158183117`*^9}, {
   3.6300288426978416`*^9, 3.630028888873722*^9}, {3.630028961085091*^9, 
   3.630028999503357*^9}, {3.63002982946698*^9, 3.630029893797064*^9}, {
   3.6300302561191196`*^9, 3.630030294472208*^9}, {3.630059484091229*^9, 
   3.6300594881907673`*^9}, {3.6300597700333233`*^9, 3.6300597893820477`*^9}, 
   3.630148098057775*^9, {3.6302236720416517`*^9, 3.630223673209177*^9}, {
   3.630223937303671*^9, 3.6302239395159187`*^9}, {3.6302239800109177`*^9, 
   3.630224002348936*^9}, {3.630281926866194*^9, 3.630281977256303*^9}, {
   3.63028204565556*^9, 3.6302820635528708`*^9}, {3.630285809260292*^9, 
   3.6302858633618813`*^9}, {3.630285918972559*^9, 3.630285927642302*^9}, {
   3.630285995266951*^9, 3.630286009636032*^9}, {3.630286063436254*^9, 
   3.630286066282868*^9}, {3.630286107443935*^9, 3.630286150996249*^9}, {
   3.6302861892126017`*^9, 3.630286236659896*^9}, 3.630286299191414*^9, {
   3.630286348452232*^9, 3.630286405488872*^9}, {3.630286534830405*^9, 
   3.630286555980999*^9}, {3.630286596772135*^9, 3.630286601489225*^9}, {
   3.630286665388907*^9, 3.63028670152229*^9}, {3.630287146242228*^9, 
   3.6302871636403418`*^9}, {3.630287414127522*^9, 3.630287426476198*^9}, {
   3.6302876245350857`*^9, 3.630287657946497*^9}, {3.630287700229747*^9, 
   3.630287716564527*^9}, {3.630287934911586*^9, 3.6302879867489147`*^9}, {
   3.630288133214734*^9, 3.630288134922318*^9}, {3.630288223301838*^9, 
   3.630288233812654*^9}, 3.630288471257818*^9, 3.630288636496207*^9, {
   3.6302886696733027`*^9, 3.6302886709397087`*^9}, 3.630288726557467*^9, 
   3.630288781797475*^9, {3.630288868184102*^9, 3.6302889870085917`*^9}, {
   3.630289291577248*^9, 3.6302893106823187`*^9}, {3.630289513230257*^9, 
   3.630289530158226*^9}, {3.630289625166292*^9, 3.6302896684410267`*^9}, {
   3.630289934419694*^9, 3.630289949612352*^9}, {3.630366865132628*^9, 
   3.630366909134102*^9}, {3.630388386107329*^9, 3.630388416341779*^9}, 
   3.63038844853113*^9, {3.630388484093947*^9, 3.630388484841198*^9}, {
   3.630390789520922*^9, 3.630390855440054*^9}, {3.630390888091436*^9, 
   3.630390889397571*^9}, {3.630410122524269*^9, 3.630410139622725*^9}, {
   3.63041023756979*^9, 3.630410248911174*^9}, {3.630410345963134*^9, 
   3.630410353915289*^9}, {3.630410402025548*^9, 3.630410434815967*^9}, {
   3.63041062993401*^9, 3.630410636509062*^9}, {3.630410683724636*^9, 
   3.630410709539404*^9}, 3.63041381725001*^9, {3.630414583461302*^9, 
   3.6304146085708637`*^9}, 3.63041491091676*^9, {3.63041498187763*^9, 
   3.6304150098023252`*^9}, {3.630415139066987*^9, 3.630415143079276*^9}, {
   3.6304155182537127`*^9, 3.6304155362892036`*^9}, {3.6304157055600367`*^9, 
   3.630415713959875*^9}, {3.630415791014086*^9, 3.6304158214907417`*^9}, {
   3.630415979472185*^9, 3.630415987602339*^9}, {3.630418022093287*^9, 
   3.6304180298072777`*^9}, {3.630418072017679*^9, 3.630418116639228*^9}, 
   3.630418306734514*^9, 3.63041844906245*^9, {3.630451269312181*^9, 
   3.630451286333696*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"refine", " ", "intervals"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"refine", "[", 
      RowBox[{"ft_", ",", "dft_", ",", "interval_", ",", "t_"}], "]"}], ":=", 
     
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"a", "=", 
         RowBox[{"Min", "[", "interval", "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"b", "=", 
         RowBox[{"Max", "[", "interval", "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{"IntervalMemberQ", "[", 
           RowBox[{
            RowBox[{"ft", "/.", 
             RowBox[{"{", 
              RowBox[{"t", "->", 
               RowBox[{"Interval", "[", 
                RowBox[{"{", 
                 RowBox[{"a", ",", "b"}], "}"}], "]"}]}], "}"}]}], ",", "0"}],
            "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"dft", "/.", 
                 RowBox[{"{", 
                  RowBox[{"t", "->", "a"}], "}"}]}], ")"}], 
               RowBox[{"(", 
                RowBox[{"dft", "/.", 
                 RowBox[{"{", 
                  RowBox[{"t", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"a", "+", "b"}], ")"}], "/", "2"}], ")"}]}], 
                  "}"}]}], ")"}]}], "<", "0"}], ",", 
             RowBox[{"b", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"a", "+", "b"}], ")"}], "/", "2"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"dft", "/.", 
                  RowBox[{"{", 
                   RowBox[{"t", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"a", "+", "b"}], ")"}], "/", "2"}], ")"}]}], 
                   "}"}]}], ")"}], "\[Equal]", "0"}], ",", 
               RowBox[{
                RowBox[{"a", "=", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"3", "a"}], "+", "b"}], ")"}], "/", "4"}]}], ";", 
                
                RowBox[{"b", "=", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"a", "+", 
                    RowBox[{"3", "b"}]}], ")"}], "/", "4"}]}]}], ",", 
               RowBox[{"a", "=", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"a", "+", "b"}], ")"}], "/", "2"}]}]}], "]"}]}], 
            "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{"Print", "[", 
           RowBox[{
            RowBox[{"N", "[", "a", "]"}], ",", "\"\<  \>\"", ",", 
            RowBox[{"N", "[", "b", "]"}]}], "]"}], "*)"}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{"Interval", "[", 
          RowBox[{"{", 
           RowBox[{"a", ",", "b"}], "}"}], "]"}], "]"}]}]}], "   ", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"return", " ", 
          RowBox[{"(", 
           RowBox[{"a", ",", "b"}], ")"}], 
          RowBox[{"(", 
           RowBox[{"\[SubsetEqual]", " ", "interval"}], ")"}], " ", "which", 
          " ", "contains", " ", "the", " ", "real", " ", "root", " ", "of", 
          " ", "df", 
          RowBox[{"(", "t", ")"}]}], "=", "0"}], ",", " ", 
        RowBox[{
         RowBox[{
         "but", " ", "not", " ", "any", " ", "real", " ", "root", " ", "of", 
          " ", "f", 
          RowBox[{"(", "t", ")"}]}], "=", "0"}]}], "*)"}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.6296938835792217`*^9, 3.629693885192501*^9}, {
   3.6298468479222*^9, 3.629846867456891*^9}, {3.629847230048429*^9, 
   3.629847236888185*^9}, {3.629847266921129*^9, 3.629847298905341*^9}, {
   3.629847357616894*^9, 3.6298473640241957`*^9}, 3.6298473982417183`*^9, {
   3.62984780183328*^9, 3.629847968729348*^9}, {3.629848010889454*^9, 
   3.6298480980999327`*^9}, {3.6298501360751047`*^9, 
   3.6298501736819057`*^9}, {3.629850238651484*^9, 3.629850287227551*^9}, {
   3.629850327579351*^9, 3.629850364179906*^9}, {3.629850669028451*^9, 
   3.6298506731881123`*^9}, {3.62985083269263*^9, 3.629850877266623*^9}, {
   3.6298509627948093`*^9, 3.629851049252795*^9}, {3.6298511168308973`*^9, 
   3.629851209884511*^9}, {3.629851260549306*^9, 3.62985133244816*^9}, {
   3.62985142193531*^9, 3.629851454308571*^9}, {3.629851493846632*^9, 
   3.629851507430251*^9}, {3.629851565269506*^9, 3.629851572987831*^9}, {
   3.6298518221748867`*^9, 3.629851864238282*^9}, {3.629852218797517*^9, 
   3.629852228894024*^9}, {3.6298523065663424`*^9, 3.62985241226143*^9}, {
   3.629852500892565*^9, 3.62985252571843*^9}, {3.629852638599784*^9, 
   3.629852653230466*^9}, {3.6298655987028837`*^9, 3.629865655006421*^9}, {
   3.6298658268812237`*^9, 3.6298658761979733`*^9}, 3.6298660400846777`*^9, {
   3.629866108875559*^9, 3.629866190791626*^9}, {3.62986631093648*^9, 
   3.629866321285159*^9}, {3.629866460318713*^9, 3.629866480232031*^9}, {
   3.629866556947715*^9, 3.62986666668369*^9}, {3.6298667158885317`*^9, 
   3.629866947537319*^9}, {3.629867082428561*^9, 3.629867090890423*^9}, {
   3.629868159740592*^9, 3.629868167588841*^9}, {3.629868207970566*^9, 
   3.629868224328133*^9}, 3.6298689411579447`*^9, {3.629869683772956*^9, 
   3.6298696927334747`*^9}, {3.6298699326358013`*^9, 3.62986994625986*^9}, 
   3.629870372580851*^9, 3.629936409006486*^9, {3.630018231442173*^9, 
   3.630018246991416*^9}, {3.630018278208329*^9, 3.63001828666448*^9}, 
   3.6300585278480043`*^9, {3.630117897793728*^9, 3.630117898210512*^9}, {
   3.6302210527457933`*^9, 3.6302211818222933`*^9}, {3.630221359261229*^9, 
   3.630221363044303*^9}, {3.630453918667549*^9, 3.6304539331700697`*^9}, 
   3.630454117652648*^9, {3.6305529600827703`*^9, 3.630552993477862*^9}, 
   3.630554640118477*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"final", " ", "refine", " ", "intervals"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"refineF", "[", 
      RowBox[{"ft_", ",", "interval_", ",", "t_", ",", "level_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"a", "=", 
         RowBox[{"Min", "[", "interval", "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"b", "=", 
         RowBox[{"Max", "[", "interval", "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"b", "-", "a"}], ")"}], ">", "level"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"ft", "/.", 
                RowBox[{"{", 
                 RowBox[{"t", "->", "a"}], "}"}]}], ")"}], 
              RowBox[{"(", 
               RowBox[{"ft", "/.", 
                RowBox[{"{", 
                 RowBox[{"t", "\[Rule]", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"a", "+", "b"}], ")"}], "/", "2"}], ")"}]}], 
                 "}"}]}], ")"}]}], "<", "0"}], ",", 
            RowBox[{"b", "=", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"a", "+", "b"}], ")"}], "/", "2"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"ft", "/.", 
                  RowBox[{"{", 
                   RowBox[{"t", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"a", "+", "b"}], ")"}], "/", "2"}], ")"}]}], 
                   "}"}]}], ")"}], "\[Equal]", "0"}], ",", 
               RowBox[{
                RowBox[{"a", "=", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"3", "a"}], "+", "b"}], ")"}], "/", "4"}]}], ";", 
                
                RowBox[{"b", "=", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"a", "+", 
                    RowBox[{"3", "b"}]}], ")"}], "/", "4"}]}]}], ",", 
               RowBox[{"a", "=", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"a", "+", "b"}], ")"}], "/", "2"}]}]}], "]"}], 
             ";"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{"Print", "[", 
           RowBox[{"a", ",", "b"}], "]"}], "*)"}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{"{", 
          RowBox[{"a", ",", "b"}], "}"}], "]"}]}]}], "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.630453948198106*^9, 3.6304540943263397`*^9}, {
   3.630454168271449*^9, 3.630454184611883*^9}, 3.630454325938246*^9, {
   3.6304543587833776`*^9, 3.6304543696515417`*^9}, {3.630455958659211*^9, 
   3.630455961019277*^9}, {3.630456171052587*^9, 3.630456263779689*^9}, {
   3.630458129432189*^9, 3.6304581431564713`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"STEP", " ", "5"}], ":", " ", 
    RowBox[{
    "LIFT", " ", "THE", " ", "SOLUTION", " ", "USING", " ", "openCAD", " ", 
     "LIFTING", " ", "PROCEDURE"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"lift", "[", 
      RowBox[{"qlist_", ",", "llist_", ",", "vlist_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "clist", ",", "rlist", ",", "templlist", ",", "tempclist", ",", 
         "lenclist", ",", "i", ",", "j", ",", "k", ",", "m"}], "}"}], ",", 
       "   ", 
       RowBox[{"(*", 
        RowBox[{"clist", ":", " ", 
         RowBox[{"sample", " ", "points"}]}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"templlist", "=", 
         RowBox[{"Sort", "[", "llist", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"tempclist", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"clist", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rlist", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", 
           RowBox[{"Length", "[", "vlist", "]"}]}], ",", 
          RowBox[{"i", ">", "1"}], ",", 
          RowBox[{"i", "--"}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"i", "==", 
              RowBox[{"Length", "[", "vlist", "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"llist", "==", 
                RowBox[{"{", "}"}]}], ",", 
               RowBox[{"clist", "=", 
                RowBox[{"{", 
                 RowBox[{"{", "1", "}"}], "}"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"For", "[", 
                RowBox[{
                 RowBox[{"k", "=", "0"}], ",", 
                 RowBox[{"k", "\[LessEqual]", 
                  RowBox[{"Length", "[", "templlist", "]"}]}], ",", 
                 RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"k", "\[Equal]", "0"}], ",", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"clist", ",", 
                    RowBox[{"{", 
                    RowBox[{"Floor", "[", 
                    RowBox[{"Min", "[", 
                    RowBox[{"templlist", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}], "}"}]}], 
                    "]"}], ";", 
                    RowBox[{"Continue", "[", "]"}]}]}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"k", "\[Equal]", 
                    RowBox[{"Length", "[", "templlist", "]"}]}], ",", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"clist", ",", 
                    RowBox[{"{", 
                    RowBox[{"Ceiling", "[", 
                    RowBox[{"Max", "[", 
                    RowBox[{"templlist", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "1"}], "]"}], "]"}], "]"}], "]"}], "}"}]}], 
                    "]"}], ";", 
                    RowBox[{"Continue", "[", "]"}]}]}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"AppendTo", "[", 
                   RowBox[{"clist", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"1", "/", "2"}], 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Max", "[", 
                    RowBox[{"templlist", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "+", 
                    RowBox[{"Min", "[", 
                    RowBox[{"templlist", "[", 
                    RowBox[{"[", 
                    RowBox[{"k", "+", "1"}], "]"}], "]"}], "]"}]}], ")"}]}], 
                    "}"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
              "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], 
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"clist", "=", 
              RowBox[{"Select", "[", 
               RowBox[{"clist", ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Length", "[", "#", "]"}], "==", 
                  RowBox[{
                   RowBox[{"Length", "[", "vlist", "]"}], "-", "i", "+", 
                   "1"}]}], "&"}]}], "]"}]}], ";"}], "*)"}], "   ", 
           RowBox[{"(*", 
            RowBox[{"remove", " ", "bad", " ", "sample", " ", "points"}], 
            "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"lenclist", "=", 
            RowBox[{"Length", "[", "clist", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"j", "=", "1"}], ",", 
             RowBox[{"j", "\[LessEqual]", "lenclist"}], ",", 
             RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"rlist", "=", 
               RowBox[{"DeleteCases", "[", 
                RowBox[{"rlist", ",", "_Rule"}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"For", "[", 
               RowBox[{
                RowBox[{"m", "=", "1"}], ",", 
                RowBox[{"m", "\[LessEqual]", 
                 RowBox[{
                  RowBox[{"Length", "[", "vlist", "]"}], "-", "i", "+", 
                  "1"}]}], ",", 
                RowBox[{"m", "++"}], ",", "\[IndentingNewLine]", 
                RowBox[{"PrependTo", "[", 
                 RowBox[{"rlist", ",", 
                  RowBox[{
                   RowBox[{"vlist", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "m"}], "]"}], "]"}], "\[Rule]", 
                   RowBox[{
                    RowBox[{"clist", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "m"}], "]"}], "]"}]}]}], "]"}]}], "]"}], ";",
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"Print", "[", "rlist", "]"}], ";"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"templlist", "=", 
               RowBox[{"DeleteCases", "[", 
                RowBox[{"templlist", ",", "_List"}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"templlist", "=", 
               RowBox[{
                RowBox[{"RootIntervals", "[", 
                 RowBox[{
                  RowBox[{"qlist", "[", 
                   RowBox[{"[", 
                    RowBox[{"i", "-", "1"}], "]"}], "]"}], "/.", "rlist"}], 
                 "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"Print", "[", "templlist", "]"}], ";"}], "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"templlist", "\[Equal]", 
                 RowBox[{"{", "}"}]}], ",", 
                RowBox[{
                 RowBox[{"PrependTo", "[", 
                  RowBox[{
                   RowBox[{"clist", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], ",", "0"}], "]"}], ";", 
                 RowBox[{"Continue", "[", "]"}]}]}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
               "set", " ", "x_i", " ", "to", " ", "0", " ", "when", " ", 
                "having", " ", "no", " ", "root", " ", 
                RowBox[{"w", ".", "r", ".", "t", ".", " ", "bad"}], " ", 
                "sample", " ", 
                RowBox[{"point", ":", " ", 
                 RowBox[{"clist", "[", 
                  RowBox[{"[", "j", "]"}], "]"}]}]}], "*)"}], 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"tempclist", "=", 
               RowBox[{"DeleteCases", "[", 
                RowBox[{"tempclist", ",", "_List"}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"tempclist", "=", 
               RowBox[{"clist", "[", 
                RowBox[{"[", "j", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{"For", "[", 
               RowBox[{
                RowBox[{"k", "=", "0"}], ",", 
                RowBox[{"k", "\[LessEqual]", 
                 RowBox[{"Length", "[", "templlist", "]"}]}], ",", 
                RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"k", "\[Equal]", "0"}], ",", 
                   RowBox[{
                    RowBox[{"PrependTo", "[", 
                    RowBox[{
                    RowBox[{"clist", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Floor", "[", 
                    RowBox[{"Min", "[", 
                    RowBox[{"templlist", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}], "-", 
                    "0.1"}]}], "]"}], ";", 
                    RowBox[{"Continue", "[", "]"}]}]}], "]"}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"k", "\[Equal]", 
                    RowBox[{"Length", "[", "templlist", "]"}]}], ",", 
                   RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"clist", ",", 
                    RowBox[{"Prepend", "[", 
                    RowBox[{"tempclist", ",", 
                    RowBox[{
                    RowBox[{"Ceiling", "[", 
                    RowBox[{"Max", "[", 
                    RowBox[{"templlist", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "1"}], "]"}], "]"}], "]"}], "]"}], "+", 
                    "0.1"}]}], "]"}]}], "]"}], ";", 
                    RowBox[{"Continue", "[", "]"}]}]}], "]"}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"clist", ",", 
                   RowBox[{"Prepend", "[", 
                    RowBox[{"tempclist", ",", 
                    RowBox[{
                    RowBox[{"1", "/", "2"}], 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Max", "[", 
                    RowBox[{"templlist", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "+", 
                    RowBox[{"Min", "[", 
                    RowBox[{"templlist", "[", 
                    RowBox[{"[", 
                    RowBox[{"k", "+", "1"}], "]"}], "]"}], "]"}]}], ")"}]}]}],
                     "]"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"Print", "[", "clist", "]"}], "*)"}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"clist", "=", 
           RowBox[{"Select", "[", 
            RowBox[{"clist", ",", 
             RowBox[{
              RowBox[{
               RowBox[{"Length", "[", "#", "]"}], "==", 
               RowBox[{"Length", "[", "vlist", "]"}]}], "&"}]}], "]"}]}], 
          ";"}], "*)"}], "   ", 
        RowBox[{"(*", 
         RowBox[{"remove", " ", "bad", " ", "sample", " ", "points"}], "*)"}],
         "\[IndentingNewLine]", 
        RowBox[{"clist", "=", 
         RowBox[{"SortBy", "[", 
          RowBox[{
           RowBox[{"Union", "[", "clist", "]"}], ",", "Last"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"clist", "=", 
           RowBox[{
            RowBox[{"Sort", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Last", "[", "#", "]"}], ",", "#"}], "}"}], "&"}], "/@", 
              RowBox[{"Union", "[", "clist", "]"}]}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", 
              RowBox[{"-", "1"}]}], "]"}], "]"}]}], ";"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"Return", " ", "[", 
         RowBox[{"N", "[", "clist", "]"}], "]"}]}]}], "   ", 
      RowBox[{"(*", 
       RowBox[{
       "return", " ", "sample", " ", "points", " ", "for", " ", "q_", "0"}], 
       "*)"}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.629936412804592*^9, 3.629936486268465*^9}, {
   3.629936617428499*^9, 3.629936677117037*^9}, {3.630036610789452*^9, 
   3.630036624245304*^9}, 3.630037205381823*^9, {3.6300372379418087`*^9, 
   3.6300372494857063`*^9}, {3.630037468390011*^9, 3.630037481982697*^9}, {
   3.630038158350585*^9, 3.630038171510804*^9}, {3.63003821273456*^9, 
   3.630038214526444*^9}, {3.630038429039764*^9, 3.630038472263938*^9}, {
   3.630038657160325*^9, 3.63003870659219*^9}, {3.6300387503439207`*^9, 
   3.630038781888386*^9}, {3.630038841481341*^9, 3.6300389167778997`*^9}, {
   3.6300395306898317`*^9, 3.630039643083395*^9}, {3.630039680668601*^9, 
   3.630039712889275*^9}, {3.630057742847766*^9, 3.630057844634705*^9}, {
   3.630057879362403*^9, 3.630057888295582*^9}, {3.630057934755849*^9, 
   3.630058026474217*^9}, {3.63005813139749*^9, 3.630058157873683*^9}, {
   3.630058275655313*^9, 3.630058280974326*^9}, {3.630058383061582*^9, 
   3.63005838834551*^9}, {3.6300584407720747`*^9, 3.63005844117982*^9}, 
   3.630058492303574*^9, {3.630058586412683*^9, 3.630058626963934*^9}, {
   3.630059306579257*^9, 3.6300593755242167`*^9}, {3.630059527180749*^9, 
   3.630059527311425*^9}, {3.63006288240469*^9, 3.630062996380924*^9}, {
   3.6300630463015738`*^9, 3.630063054210836*^9}, {3.630063102584516*^9, 
   3.63006314335146*^9}, {3.630063322308798*^9, 3.630063323343256*^9}, {
   3.630063366832212*^9, 3.630063373047686*^9}, {3.630064171264056*^9, 
   3.6300641723407393`*^9}, {3.63006447232408*^9, 3.630064521355743*^9}, {
   3.6300645515467978`*^9, 3.6300645747043858`*^9}, {3.630114732824273*^9, 
   3.6301147369906397`*^9}, {3.630114812563211*^9, 3.630114826386265*^9}, {
   3.630115056205667*^9, 3.630115057326873*^9}, {3.630115540088827*^9, 
   3.630115543866928*^9}, {3.6301155755991383`*^9, 3.630115608843277*^9}, {
   3.6301156539822607`*^9, 3.630115740385768*^9}, {3.6301158636335163`*^9, 
   3.630115865407606*^9}, {3.630116052464614*^9, 3.630116089174733*^9}, {
   3.63011613521912*^9, 3.63011613853701*^9}, {3.630117383375246*^9, 
   3.6301173965602207`*^9}, {3.63011779754314*^9, 3.630117798704808*^9}, {
   3.630117983615346*^9, 3.6301179913393497`*^9}, {3.630118150969748*^9, 
   3.630118155406598*^9}, {3.6301182258101587`*^9, 3.630118287572481*^9}, {
   3.6301183537056007`*^9, 3.630118357328918*^9}, {3.630118687103528*^9, 
   3.630118752863439*^9}, {3.630118797171144*^9, 3.630118816650488*^9}, {
   3.630118888906041*^9, 3.63011899065212*^9}, {3.630119087162245*^9, 
   3.630119115478044*^9}, {3.6301192153393106`*^9, 3.630119221922133*^9}, {
   3.630119333738613*^9, 3.630119337501288*^9}, {3.630119368847186*^9, 
   3.630119375421527*^9}, {3.630119548322688*^9, 3.6301195656200743`*^9}, {
   3.630119690018244*^9, 3.630119695016206*^9}, {3.630120081755108*^9, 
   3.6301200821999683`*^9}, 3.630120116090197*^9, {3.630120194757393*^9, 
   3.630120200554535*^9}, {3.6301202860841837`*^9, 3.63012030898449*^9}, {
   3.630120354457131*^9, 3.630120407515126*^9}, {3.6301212059636908`*^9, 
   3.6301212224152117`*^9}, {3.630121267000217*^9, 3.630121280428516*^9}, {
   3.630121311031391*^9, 3.630121338078658*^9}, {3.630121370071129*^9, 
   3.63012138591566*^9}, {3.630121416277184*^9, 3.630121421136313*^9}, {
   3.630121804172714*^9, 3.630121838554449*^9}, {3.630121884989334*^9, 
   3.630121887149856*^9}, {3.630122036556444*^9, 3.6301220678615513`*^9}, {
   3.630122204134059*^9, 3.630122249604566*^9}, {3.630122293126851*^9, 
   3.630122340043179*^9}, {3.63012238943843*^9, 3.630122448536641*^9}, {
   3.630122488478281*^9, 3.63012250766844*^9}, 3.630122565118353*^9, {
   3.630122673867078*^9, 3.630122675098187*^9}, {3.6301228068015327`*^9, 
   3.6301228697205057`*^9}, {3.630122941066372*^9, 3.630122966772493*^9}, {
   3.630123181642332*^9, 3.630123185722221*^9}, {3.630123356349025*^9, 
   3.630123378690096*^9}, {3.6301234149631968`*^9, 3.630123543924286*^9}, 
   3.630123575089965*^9, {3.630123617069133*^9, 3.6301236470747213`*^9}, {
   3.63012368485492*^9, 3.630123753099698*^9}, {3.630123821584586*^9, 
   3.6301238363853397`*^9}, {3.630123900390586*^9, 3.630123938679925*^9}, {
   3.630124049073732*^9, 3.6301240775169353`*^9}, {3.6301243180054893`*^9, 
   3.6301243333419847`*^9}, {3.630124373368949*^9, 3.630124379781639*^9}, {
   3.630124446974538*^9, 3.630124476310491*^9}, {3.630124522462455*^9, 
   3.6301245456702423`*^9}, {3.6301245817900677`*^9, 3.630124613817707*^9}, {
   3.6301247420387697`*^9, 3.630124765966341*^9}, {3.6301248226814833`*^9, 
   3.630124895094136*^9}, {3.630124930355098*^9, 3.630124939776493*^9}, {
   3.630125032889821*^9, 3.6301250874103107`*^9}, {3.6301252196824627`*^9, 
   3.63012523084523*^9}, {3.6301252734438953`*^9, 3.630125285150775*^9}, {
   3.630125360382752*^9, 3.630125361468678*^9}, {3.630125424042094*^9, 
   3.630125450016767*^9}, {3.630125484457246*^9, 3.6301254852322483`*^9}, {
   3.6301256507534113`*^9, 3.63012566091288*^9}, {3.630125936686716*^9, 
   3.630125936798814*^9}, {3.6301260609694843`*^9, 3.630126061246003*^9}, {
   3.6301266238774023`*^9, 3.630126627568295*^9}, {3.630126928093955*^9, 
   3.630126964573928*^9}, {3.630127046944672*^9, 3.630127163297585*^9}, {
   3.630127436617365*^9, 3.630127441787896*^9}, 3.630127560636889*^9, {
   3.630127642176194*^9, 3.63012769796299*^9}, {3.630127749437499*^9, 
   3.630127780752055*^9}, {3.630127819618002*^9, 3.6301278354427557`*^9}, {
   3.630128177755368*^9, 3.630128185605402*^9}, {3.630128311913064*^9, 
   3.630128347122567*^9}, {3.630128402278618*^9, 3.630128403359272*^9}, 
   3.630128465529702*^9, {3.630128518051092*^9, 3.630128576923139*^9}, {
   3.63020332846982*^9, 3.630203352737612*^9}, {3.6302039256848593`*^9, 
   3.63020394854679*^9}, {3.630204150877245*^9, 3.630204156970179*^9}, {
   3.630204212968355*^9, 3.630204241225268*^9}, {3.630204313426251*^9, 
   3.630204325912424*^9}, {3.6302277259812107`*^9, 3.630227740761311*^9}, {
   3.630227887433742*^9, 3.63022789296682*^9}, {3.630227986056521*^9, 
   3.630228024998479*^9}, {3.630228080945252*^9, 3.6302280857957973`*^9}, {
   3.630228117361063*^9, 3.6302281252341137`*^9}, {3.630228241740444*^9, 
   3.630228245858942*^9}, {3.630228515442649*^9, 3.630228533040354*^9}, {
   3.630229847373632*^9, 3.6302298720205173`*^9}, {3.6302390085884113`*^9, 
   3.630239023334567*^9}, {3.630243743206607*^9, 3.630243745077177*^9}, {
   3.630243931437194*^9, 3.630243932095829*^9}, {3.6302440645048637`*^9, 
   3.630244066761538*^9}, {3.630363808316818*^9, 3.63036381280056*^9}, {
   3.630452399398675*^9, 3.6304524229979258`*^9}, 3.630452485357072*^9, {
   3.630452602747499*^9, 3.6304526402286167`*^9}, {3.6304529232314577`*^9, 
   3.6304529458368053`*^9}, {3.630504191290143*^9, 3.6305042176259203`*^9}, {
   3.630505619069113*^9, 3.630505663063339*^9}, 3.6305073834431057`*^9, {
   3.630554531617776*^9, 3.6305545701628838`*^9}, 3.630554698290604*^9, {
   3.630554728330749*^9, 3.630554780378587*^9}, {3.630559965829122*^9, 
   3.630559978509552*^9}, {3.6305603032335653`*^9, 3.630560337817687*^9}, {
   3.630560392119258*^9, 3.630560395740796*^9}, {3.630561376406672*^9, 
   3.630561412282454*^9}, 3.63056146561241*^9, {3.6305615148353033`*^9, 
   3.630561576768841*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"STEP", " ", "6"}], ":", " ", 
    RowBox[{
    "CHECK", " ", "\[CapitalPhi]", " ", "WITH", " ", "OBTAINED", " ", 
     "SAMPLE", " ", "POINTS"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"check", "[", 
     RowBox[{"q0_", ",", "vlist_", ",", "rlist_", ",", "points_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "target", ",", "sat", ",", "flag", ",", "satpoints", ",", "i", ",", 
        "j"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"sat", "=", "False"}], ";", "\[IndentingNewLine]", 
       RowBox[{"satpoints", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"target", "=", 
        RowBox[{"q0", "/.", "rlist"}]}], ";", "   ", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"Print", "[", "points", "]"}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", "points", "]"}]}], ",", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"flag", "=", "True"}], ";", "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"j", "=", "1"}], ",", 
            RowBox[{"j", "\[LessEqual]", 
             RowBox[{"Length", "[", "target", "]"}]}], ",", 
            RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{"flag", ",", 
              RowBox[{"flag", "=", 
               RowBox[{"flag", "&&", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"target", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "/.", 
                    RowBox[{"Thread", "[", 
                    RowBox[{"vlist", "\[Rule]", 
                    RowBox[{"points", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], ")"}], "<", 
                  "0"}], ")"}]}]}], ",", 
              RowBox[{"Break", "[", "]"}]}], "]"}]}], "]"}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{"flag", ",", 
            RowBox[{
             RowBox[{"sat", "=", "True"}], ";", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"satpoints", ",", 
               RowBox[{"points", "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}]}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", "sat", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "satpoints", "]"}]}]}], "\[IndentingNewLine]", 
     "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQBWIQnRYVtX4Jz2tHMduMjSDaulB9O4ietH7SLhD9zfna
PhCt79d7CET/Szxy8AD/a8cv+/4eAdHCc+1vgOhlD7/fBNFxKb73QbTvd6mn
ILo12/IViLZLEHsNormX53wE0fLzs76D6EuW6xgPAum9QUXMIDo16E8MiK7y
n5MMojfxxpSAaI67atNAtF0s30IQPa++CUxPXX1hNYhW63i/BkQfudx0EkTv
vOR0CkRPmi/5CURPibf9DaInHH/6H0QbeDswHwLSbHu62UH0kzR5LhD9YP0v
XRDNd3+qGYjmuqljA6K3/a/2AdEK9nKBIFrw2MtwEL3ybHciiK5Xdk0D0QC4
26oD
  "]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"**", "**"}], "**"}], "**"}], "**"}], "**"}], "**"}],
             "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], "**"}], "**",
     "**", "EXAMPLE"}], " ", 
   RowBox[{"1", "**", "**", "**"}], "*", "*", 
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}]}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.632142090531392*^9, 3.632142160379325*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"q0", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"x1", "^", "2"}], "+", 
     RowBox[{"x2", "^", "2"}], "+", 
     RowBox[{"x3", "^", "2"}], "-", "1"}], ")"}], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"a", " ", "x1"}], "+", 
     RowBox[{"b", " ", "x2"}], "+", 
     RowBox[{"c", " ", "x3"}], "+", "h"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.630513507096222*^9, 3.6305135093527822`*^9}, {
  3.632137093663912*^9, 3.632137121179246*^9}, {3.6321423680258417`*^9, 
  3.632142369851454*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"h", "+", 
    RowBox[{"a", " ", "x1"}], "+", 
    RowBox[{"b", " ", "x2"}], "+", 
    RowBox[{"c", " ", "x3"}]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    SuperscriptBox["x1", "2"], "+", 
    SuperscriptBox["x2", "2"], "+", 
    SuperscriptBox["x3", "2"]}], ")"}]}]], "Output",
 CellChangeTimes->{3.632142375317597*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rlist", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "->", 
     RowBox[{"E", "^", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Sqrt", "[", "2", "]"}], "t"}], ")"}]}]}], ",", 
    RowBox[{"b", "->", 
     RowBox[{"E", "^", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Sqrt", "[", "2", "]"}]}], "t"}], ")"}]}]}], ",", 
    RowBox[{"c", "\[Rule]", 
     RowBox[{"E", "^", 
      RowBox[{"(", 
       RowBox[{"-", "t"}], ")"}]}]}], ",", 
    RowBox[{"h", "->", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"E", "^", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Sqrt", "[", "2", "]"}]}], " ", "t"}], ")"}]}], ")"}], 
       "/", 
       RowBox[{"(", 
        RowBox[{"3", "+", 
         RowBox[{"2", " ", 
          RowBox[{"Sqrt", "[", "2", "]"}]}]}], ")"}]}], "+", 
      RowBox[{"t", " ", 
       RowBox[{"E", "^", 
        RowBox[{"(", 
         RowBox[{"-", "t"}], ")"}]}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Sqrt", "[", "2", "]"}], " ", "t"}], "-", 
         RowBox[{"Sqrt", "[", "2", "]"}], "+", "5"}], ")"}], "/", "2"}], "+", 
      
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"Sqrt", "[", "2", "]"}]}], ")"}], "t"}], "-", "1"}], 
         ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"3", "+", 
          RowBox[{"2", " ", 
           RowBox[{"Sqrt", "[", "2", "]"}]}]}], ")"}]}], 
       RowBox[{"E", "^", "t"}]}], "+", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Sqrt", "[", "2", "]"}], "-", "1"}], ")"}], "/", "2"}], " ", 
       RowBox[{"E", "^", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Sqrt", "[", "2", "]"}], "t"}], ")"}]}]}]}]}]}], 
   "}"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"a", "\[Rule]", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      SqrtBox["2"], " ", "t"}]]}], ",", 
   RowBox[{"b", "\[Rule]", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", 
       SqrtBox["2"]}], " ", "t"}]]}], ",", 
   RowBox[{"c", "\[Rule]", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"-", "t"}]]}], ",", 
   RowBox[{"h", "\[Rule]", 
    RowBox[{
     FractionBox[
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", 
         SqrtBox["2"]}], " ", "t"}]], 
      RowBox[{"3", "+", 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]}]], "+", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SqrtBox["2"]}], ")"}], " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        SqrtBox["2"], " ", "t"}]]}], "+", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"-", "t"}]], " ", "t"}], "+", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"5", "-", 
        SqrtBox["2"], "+", 
        RowBox[{
         SqrtBox["2"], " ", "t"}]}], ")"}]}], "+", 
     FractionBox[
      RowBox[{
       SuperscriptBox["\[ExponentialE]", "t"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SqrtBox["2"]}], ")"}], " ", "t"}]}], ")"}]}], 
      RowBox[{"3", "+", 
       RowBox[{"2", " ", 
        SqrtBox["2"]}]}]]}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.632142403879767*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"main", "[", 
  RowBox[{"q0", ",", 
   RowBox[{"{", 
    RowBox[{"x1", ",", "x2", ",", "x3"}], "}"}], ",", "rlist", ",", "t", ",", 
   
   RowBox[{"Interval", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1.5"}], "}"}], "]"}], ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.632137306064579*^9, 3.6321373072407017`*^9}, {
  3.632139886435217*^9, 3.6321399066903143`*^9}}],

Cell[CellGroupData[{

Cell[BoxData["True"], "Print",
 CellChangeTimes->{3.632142462269363*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", "0.8354887466511607`"}], ",", 
    RowBox[{"-", "0.21210824013705407`"}], ",", "0.18447291600443638`", ",", 
    "2.`"}], "}"}], "}"}]], "Print",
 CellChangeTimes->{3.632142462271017*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{960, 1148},
WindowMargins->{{-10, Automatic}, {Automatic, -10}},
FrontEndVersion->"10.0 for Linux x86 (64-bit) (December 4, 2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 12439, 248, 935, "Input"],
Cell[13000, 270, 6170, 130, 429, "Input"],
Cell[19173, 402, 24923, 510, 1661, "Input"],
Cell[44099, 914, 19796, 400, 1309, "Input"],
Cell[63898, 1316, 6487, 144, 407, "Input"],
Cell[70388, 1462, 3586, 92, 385, "Input"],
Cell[73977, 1556, 20442, 405, 1287, "Input"],
Cell[94422, 1963, 3315, 79, 363, "Input"],
Cell[97740, 2044, 715, 24, 32, "Input"],
Cell[CellGroupData[{
Cell[98480, 2072, 536, 15, 32, "Input"],
Cell[99019, 2089, 405, 13, 37, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[99461, 2107, 1964, 67, 77, "Input"],
Cell[101428, 2176, 1651, 57, 102, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[103116, 2238, 399, 10, 32, "Input"],
Cell[CellGroupData[{
Cell[103540, 2252, 72, 1, 23, "Print"],
Cell[103615, 2255, 261, 7, 23, "Print"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
